// SmartListView.cpp : implementation file
//

#include "stdafx.h"
#include "DictionaryEditor.h"
#include "SmartListView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSmartListView

IMPLEMENT_DYNCREATE(CSmartListView, CListView)

CSmartListView::CSmartListView()
{
}

CSmartListView::~CSmartListView()
{
}


BEGIN_MESSAGE_MAP(CSmartListView, CListView)
	//{{AFX_MSG_MAP(CSmartListView)
	ON_NOTIFY_REFLECT(LVN_DELETEITEM, OnDeleteitem)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSmartListView drawing

/*void CSmartListView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}*/

/////////////////////////////////////////////////////////////////////////////
// CSmartListView diagnostics

#ifdef _DEBUG
void CSmartListView::AssertValid() const
{
	CListView::AssertValid();
}

void CSmartListView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSmartListView message handlers

BOOL CSmartListView::SortTextItems(int nCol, BOOL bAscending, int low, int high)
{
	if( nCol >= ((CHeaderCtrl*)GetDlgItem(0))->GetItemCount() )
		return FALSE;

	if( high == -1 ) high = GetListCtrl().GetItemCount() - 1;

	int lo = low;
	int hi = high;
	CString midItem;

	if(hi <= lo)
		return FALSE;

	midItem = GetListCtrl().GetItemText((lo+hi)/2, nCol);

	// loop through the list until indices cross
	while( lo <= hi )
	{
		// rowText will hold all column text for one row
		CStringArray rowText;

		// find the first element that is greater than or equal to 
		// the partition element starting from the left Index.
		if(bAscending)
		{
			while((lo < high) && (GetListCtrl().GetItemText(lo, nCol).CompareNoCase(midItem) < 0))
				++lo;
		}
		else
		{
			while((lo < high) && (GetListCtrl().GetItemText(lo, nCol).CompareNoCase(midItem) > 0))
				++lo;
		}

		// find an element that is smaller than or equal to 
		// the partition element starting from the right Index.
		if( bAscending )
		{
			while(( hi > low) && (GetListCtrl().GetItemText(hi, nCol).CompareNoCase(midItem) > 0))
				--hi;
		}
		else
		{
			while(( hi > low) && (GetListCtrl().GetItemText(hi, nCol).CompareNoCase(midItem) < 0))
				--hi;
		}

		// if the indexes have not crossed, swap
		// and if the items are not equal
		if( lo <= hi )
		{
			// swap only if the items are not equal
			if(GetListCtrl().GetItemText(lo, nCol).CompareNoCase(GetListCtrl().GetItemText(hi, nCol)) != 0)
			{
				// swap the rows
				LV_ITEM lvitemlo, lvitemhi;
				int nColCount = 
					((CHeaderCtrl*)GetDlgItem(0))->GetItemCount();
				rowText.SetSize( nColCount );
				int i;
				for( i=0; i<nColCount; i++)
				{
					rowText[i] = GetListCtrl().GetItemText(lo, i);
				}
				lvitemlo.mask = LVIF_IMAGE | LVIF_PARAM | LVIF_STATE;
				lvitemlo.iItem = lo;
				lvitemlo.iSubItem = 0;
				lvitemlo.stateMask = LVIS_CUT | LVIS_DROPHILITED | 
						LVIS_FOCUSED |  LVIS_SELECTED | 
						LVIS_OVERLAYMASK | LVIS_STATEIMAGEMASK;

				lvitemhi = lvitemlo;
				lvitemhi.iItem = hi;

				GetListCtrl().GetItem( &lvitemlo );
				GetListCtrl().GetItem( &lvitemhi );

				for( i=0; i<nColCount; i++)
				{
					GetListCtrl().SetItemText(lo, i, GetListCtrl().GetItemText(hi, i));
				}

				lvitemhi.iItem = lo;
				GetListCtrl().SetItem( &lvitemhi );

				for( i=0; i<nColCount; i++)
				{
					GetListCtrl().SetItemText(hi, i, rowText[i]);
				}

				lvitemlo.iItem = hi;
				GetListCtrl().SetItem( &lvitemlo );
			}

			++lo;
			--hi;
		}
	}

	// If the right index has not reached the left side of array
	// must now sort the left partition.
	if( low < hi )
		SortTextItems( nCol, bAscending , low, hi);

	// If the left index has not reached the right side of array
	// must now sort the right partition.
	if( lo < high )
		SortTextItems( nCol, bAscending , lo, high );

	return TRUE;
}

BOOL CSmartListView::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style |= LVS_OWNERDRAWFIXED;
	
	return CListView::PreCreateWindow(cs);
}

void CSmartListView::OnDeleteitem(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
//	GetListCtrl().OnInitialUpdate();
	//OnPaint();
	GetListCtrl().RedrawItems(0, GetListCtrl().GetItemCount());
	*pResult = 0;
}

void CSmartListView::DeleteAll2()
{
	SetRedraw(FALSE);

	int nItem = GetListCtrl().GetNextItem(-1, LVNI_ALL);
	while(nItem != -1)
	{
		GetListCtrl().DeleteItem(nItem);
		nItem = GetListCtrl().GetNextItem(-1, LVNI_ALL);
	}

	SetRedraw(TRUE);
}
